searchData={"items":[{"type":"module","title":"ExTwelveData.RealTimePrices","doc":"WebSocket client to get real-time prices from Twelve Data.","ref":"ExTwelveData.RealTimePrices.html"},{"type":"function","title":"ExTwelveData.RealTimePrices.reset/1","doc":"Reset the subscription to all price updates.","ref":"ExTwelveData.RealTimePrices.html#reset/1"},{"type":"function","title":"ExTwelveData.RealTimePrices.start_link/1","doc":"","ref":"ExTwelveData.RealTimePrices.html#start_link/1"},{"type":"function","title":"ExTwelveData.RealTimePrices.subscribe/2","doc":"Specify a list of symbols you're interested to.\n\nSubsequent calls will append new symbols to the list.\nSee `unsubscribe/2` and `reset/1` to remove","ref":"ExTwelveData.RealTimePrices.html#subscribe/2"},{"type":"function","title":"ExTwelveData.RealTimePrices.unsubscribe/2","doc":"Send a list of symbols that you're no longer interested to.\n\nTwelve Data will stop sending updates.","ref":"ExTwelveData.RealTimePrices.html#unsubscribe/2"},{"type":"type","title":"ExTwelveData.RealTimePrices.option/0","doc":"","ref":"ExTwelveData.RealTimePrices.html#t:option/0"},{"type":"type","title":"ExTwelveData.RealTimePrices.options/0","doc":"","ref":"ExTwelveData.RealTimePrices.html#t:options/0"},{"type":"type","title":"ExTwelveData.RealTimePrices.symbols_list/0","doc":"Symbols passed to subscribe/unsubscribe.\n\nIt can either be an array of objects (extended format),\nor a comma-delimited string with multiple symbols.","ref":"ExTwelveData.RealTimePrices.html#t:symbols_list/0"},{"type":"behaviour","title":"ExTwelveData.RealTimePrices.Handler","doc":"Implement the Handler behaviour to process real-time price updates coming from Twelve Data.","ref":"ExTwelveData.RealTimePrices.Handler.html"},{"type":"callback","title":"ExTwelveData.RealTimePrices.Handler.handle_price_update/1","doc":"Invoked when a price update is received.","ref":"ExTwelveData.RealTimePrices.Handler.html#c:handle_price_update/1"},{"type":"type","title":"ExTwelveData.RealTimePrices.Handler.price/0","doc":"","ref":"ExTwelveData.RealTimePrices.Handler.html#t:price/0"},{"type":"module","title":"ExTwelveData.RealTimePrices.SubscriptionsManager","doc":"High-level client to manage subscriptions to the real-time prices endpoint.\n\nIt avoids hitting the rate limits, and batches subscribe and unsubscribe requests.\nSubscriptionsManager expects a list of symbols, and creates a subscription for **at least** those symbols.\nIt is implemented as a GenServer, which schedules a message every 600ms (100 events/minute), to subscribe/unsubscribe.\n\n>","ref":"ExTwelveData.RealTimePrices.SubscriptionsManager.html"},{"type":"module","title":"What do the 100 events per minute limit stand for? - ExTwelveData.RealTimePrices.SubscriptionsManager","doc":"> This does not affect how many price updates might be received from the server, but instead,\n> it limits how many events (subscribe/unsubscribe/reset) could be sent to the server from the client side.\n>\n> -- from https://support.twelvedata.com/en/articles/5194610-websocket-faq","ref":"ExTwelveData.RealTimePrices.SubscriptionsManager.html#module-what-do-the-100-events-per-minute-limit-stand-for"},{"type":"function","title":"ExTwelveData.RealTimePrices.SubscriptionsManager.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ExTwelveData.RealTimePrices.SubscriptionsManager.html#child_spec/1"},{"type":"function","title":"ExTwelveData.RealTimePrices.SubscriptionsManager.handle_info/2","doc":"Runs every @clock_period_ms to honour the rate limit.\n\nIt checks with the configured {SubscriptionsManager.Provider} behaviour what to add/remove,\nand sends the corresponding subscribe/unsubscribe message to Twelve Data.","ref":"ExTwelveData.RealTimePrices.SubscriptionsManager.html#handle_info/2"},{"type":"function","title":"ExTwelveData.RealTimePrices.SubscriptionsManager.init/1","doc":"","ref":"ExTwelveData.RealTimePrices.SubscriptionsManager.html#init/1"},{"type":"function","title":"ExTwelveData.RealTimePrices.SubscriptionsManager.start_link/1","doc":"","ref":"ExTwelveData.RealTimePrices.SubscriptionsManager.html#start_link/1"},{"type":"type","title":"ExTwelveData.RealTimePrices.SubscriptionsManager.option/0","doc":"","ref":"ExTwelveData.RealTimePrices.SubscriptionsManager.html#t:option/0"},{"type":"type","title":"ExTwelveData.RealTimePrices.SubscriptionsManager.options/0","doc":"","ref":"ExTwelveData.RealTimePrices.SubscriptionsManager.html#t:options/0"},{"type":"behaviour","title":"ExTwelveData.RealTimePrices.SubscriptionsManager.Provider","doc":"Implement the Provider behaviour to use the SubscriptionsManager.\n\nIt should return a set containing Twelve Data symbols that the user wants to subscribe to.","ref":"ExTwelveData.RealTimePrices.SubscriptionsManager.Provider.html"},{"type":"callback","title":"ExTwelveData.RealTimePrices.SubscriptionsManager.Provider.get_symbols/0","doc":"Invoked by the subscriptions manager.\n\nShoud provide the set of Twelve Data symbols to subscribe to at this point in time.","ref":"ExTwelveData.RealTimePrices.SubscriptionsManager.Provider.html#c:get_symbols/0"},{"type":"module","title":"ExTwelveData.RealTimePrices.SubscriptionsManager.QuotaTracker","doc":"Helpers to decide whether to remove or add items","ref":"ExTwelveData.RealTimePrices.SubscriptionsManager.QuotaTracker.html"},{"type":"function","title":"ExTwelveData.RealTimePrices.SubscriptionsManager.QuotaTracker.action/3","doc":"","ref":"ExTwelveData.RealTimePrices.SubscriptionsManager.QuotaTracker.html#action/3"},{"type":"module","title":"ExTwelveData.Supervisor","doc":"Supervisor for the RealTimePrices and SubscriptionsManager processes.\n\nIt starts the RealTimePrices and SubscriptionsManager processes, and restarts them if they crash.\nThis is important since the RealTimePrices client has an implicit state with the Twelve Data connection:\nthe list of symbols that are subscribed to is determined by the sequence of subscribe/unsubscribe messages.\nIf the RealTimePrices process crashes, the state is lost, and the list of subscribed symbols is reset.\nThis supervisor ensures that when the RealTimePrices process crashes,\nit is restarted with a fresh SubscriptionManager process, which will then have a clean state,\nand restart the entire flow.","ref":"ExTwelveData.Supervisor.html"},{"type":"function","title":"ExTwelveData.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ExTwelveData.Supervisor.html#child_spec/1"},{"type":"function","title":"ExTwelveData.Supervisor.init/1","doc":"","ref":"ExTwelveData.Supervisor.html#init/1"},{"type":"function","title":"ExTwelveData.Supervisor.start_link/1","doc":"","ref":"ExTwelveData.Supervisor.html#start_link/1"},{"type":"type","title":"ExTwelveData.Supervisor.option/0","doc":"","ref":"ExTwelveData.Supervisor.html#t:option/0"},{"type":"type","title":"ExTwelveData.Supervisor.options/0","doc":"","ref":"ExTwelveData.Supervisor.html#t:options/0"},{"type":"module","title":"ExTwelveData.Symbol","doc":"Struct to represent a Twelve Data extended symbol.","ref":"ExTwelveData.Symbol.html"},{"type":"type","title":"ExTwelveData.Symbol.instrument_types/0","doc":"Supports: Stock, Index, ETF, REIT","ref":"ExTwelveData.Symbol.html#t:instrument_types/0"},{"type":"type","title":"ExTwelveData.Symbol.t/0","doc":"Extended format for Twelve Data symbols.","ref":"ExTwelveData.Symbol.html#t:t/0"}],"content_type":"text/markdown"}